import React, {PropTypes, Component}  from 'react';
import {fabric} from 'fabric-webpack';
// import '../style.scss';
import EventListener from 'react-event-listener';
import {TweenMax} from 'gsap';
import Toolbox from './Toolbox';
import CanvasEvents from './events/CanvasEvents';
import PubSub from 'pubsub-js'
// var fabric = require('./fabric');

function getStyles(props, context) {
    // const {tabs} = context.muiTheme;

    return {
        wrapper: {
            // backgroundColor: props.config.bgColor ? props.config.bgColor : '',
            width: '100%',
            height: '100%',
            // minWidth:1000
        },
        canvas: {
            display: 'flex',
            flexDirection: 'column',
            alignItems: 'center', /**/
            justifyContent: 'center',
            height: (props.label && props.icon) ? 72 : 48,
        },
    };
}

let canvas;
let self;
let original;

class Document extends Component {

    constructor(){
        super();
        self = this;
    }

    static canvasId = 'postCanvas';

    static propTypes = {
        /**
         * The Document setting
         */
        config: PropTypes.object,
        /**
         * templateData
         */
        templateData: PropTypes.object,
        /**
         * callback on canvasElement change state.
         */
        onChanged: PropTypes.func,
        /**
         * Sets the text value of the tab item to the string specified.
         */
    };

    static area = {width: 0.7, height: 0.8};

    // root = this;

    canvasEventHandle(e) {
        // console.log(e,this)
        // canvas.setZoom(Math.random() * 2)
        // console.log(canvas.getZoom())
        console.log('this:',this);
        // root.zoom();
        PubSub.publish(CanvasEvents.SELECTED,{e,this});
    };

    onObjectSelected(msg,data){
        // console.log(data,this);
        this.doSelected();

    }

    doSelected(){
        console.log("asdfasdf")
    }


    fitToScreen() {


        let aw, ah, cw, ch,
            size = {width:0,height:0,scaleFactor:1},
            screenWidth = window.innerWidth,
            screenHeight = window.innerHeight;

            // console.log(window,screenWidth);

        aw = screenWidth * Document.area.width;
        ah = screenHeight * Document.area.height;

        cw = original.width;
        ch = original.height;


        if (cw / ch > aw / ah) {
            size.width = aw;
            size.height = ch / cw * aw;
            size.scaleFactor = aw/cw;
            console.log('fitWidht:',size)
        }else{
            size.height = ah;
            size.width = cw / ch * ah;
            size.scaleFactor = ah/ch;
            console.log('fitHeight:',size)
        }


        canvas.setHeight(size.height);
        canvas.setWidth(size.width);
        canvas.setZoom(size.scaleFactor);

        // console.log(screenHeight,size.height);

        TweenMax.to('.canvas-container',.5,{left:(screenWidth-size.width)/2,top:(screenHeight-size.height)/2,ease:Power1.easeInOut})


    };

    onResizeHandle(e) {
        // console.log(this, e);
        this.fitToScreen()
        // console.log(root)
        //root.zoom();
    }

    onMouseDownHandle() {
        // console.log(TweenMax);
        // console.log(root);
        // TweenMax.fromTo('.canvas-container',2,{scale:0.8,alpha:0},{scale:1,alpha:1,ease:Power2.easeInOut})
    }

    componentDidMount() {
        canvas = new fabric.Canvas(Document.canvasId, {
            backgroundColor: 'rgb(255,255,255)',
            width: '500',
            height: '800'
        });

        self = this;
        original = {width: 500, height: 800};

        fabric.Object.prototype.borderColor = '#6dc3d3';
        fabric.Object.prototype.cornerColor = '#6dc3d3';
        fabric.Object.prototype.cornerStyle = 'circle';
        fabric.Object.prototype.cornerSize = 20;
        fabric.Object.prototype.cornerStrokeColor = '#ffffff';
        fabric.Object.prototype.borderScaleFactor = 0.4;
        fabric.Object.prototype.transparentCorners = false;
        fabric.Object.prototype.setControlsVisibility({
            tl: true,
            tr: true,
            br: true,
            bl: true,
            ml: false,
            mt: false,
            mr: false,
            mb: false,
            mtr: true
        });

        console.log(fabric.Object.prototype);

        canvas.loadFromJSON('{"objects":[{"type":"rect","left":50,"top":50,"width":50,"height":50,"fill":"green","overlayFill":null,"stroke":null,"strokeWidth":1,"strokeDashArray":null,"scaleX":1,"scaleY":1,"angle":0,"flipX":false,"flipY":false,"opacity":1,"selectable":true,"hasControls":true,"hasBorders":true,"hasRotatingPoint":true,"transparentCorners":false,"perPixelTargetFind":false,"rx":0,"ry":0},{"type":"circle","left":100,"top":100,"width":100,"height":100,"fill":"red","overlayFill":null,"stroke":null,"strokeWidth":1,"strokeDashArray":null,"scaleX":1,"scaleY":1,"angle":0,"flipX":false,"flipY":false,"opacity":1,"selectable":true,"hasControls":true,"hasBorders":true,"hasRotatingPoint":false,"transparentCorners":false,"perPixelTargetFind":false,"radius":50}]}');

        var textBox = new fabric.Text("POP/aPock", {
            fontSize: '12',
            textAlign: 'center'
        });
        textBox.editable = false;


        canvas.add(textBox);

        fabric.Image.fromURL('../example/img/titleBg.svg', function (image) {
            canvas.add(image);
        })


        canvas.on(
            {'object:selected': this.canvasEventHandle.bind(this)}
        );

        PubSub.subscribe(CanvasEvents.SELECTED,this.onObjectSelected.bind(this));

        // this.setState({canvas}, () => {
        //     this.initEvent.call(this);
        //     Object.keys(this.ref).forEach(key => {
        //         const ref = this.ref[key];
        //         ref.draw(obj => this.add(obj));
        //     });
        // });
       this.fitToScreen();
    }

    render() {
        const styles = getStyles(this.props);

        return (
            <div className="document-Wrapper" style={styles.wrapper}>
                <EventListener target='window' onResize={this.onResizeHandle.bind(this)}/>
                <EventListener target={document} onMouseDown={this.onMouseDownHandle}/>
                <canvas id={Document.canvasId}/>
                <Toolbox/>
            </div>

        );
    }
}

export  default  Document;
