import React, {PropTypes, Component}  from 'react';
import {fabric} from 'fabric-webpack';
import EventListener from 'react-event-listener';
import {TweenMax} from 'gsap';
import PubSub from 'pubsub-js'


import CanvasEvents from '../events/CanvasEvents'
import ToolBoxEvents from '../events/ToolBoxEvents'

import postData from '../data/PostData';

import '../style.scss';


function getStyles(props, context) {
    // const {tabs} = context.muiTheme;

    return {
        // toolbox: {
        //     position: 'absolute',
        //     right: 20,
        //     top: '30%'
        // }
    };
}

let canvas;


class Canvas extends Component {

    constructor() {
        super();

        this.original = {};

    }

    static id = 'postCanvas';

    static propTypes = {
        templateData: PropTypes.object,
        toolBox: PropTypes.object
    };

    static area = {width: 0.7, height: 0.8};


    componentDidMount() {
        canvas = new fabric.Canvas(Canvas.id, {
            backgroundColor: 'rgb(255,255,255)',
            width: '500',
            height: '800'
        });
        //
        // self = this;
        this.original = {width: 500, height: 800};
        //
        fabric.Object.prototype.borderColor = '#6dc3d3';
        fabric.Object.prototype.cornerColor = '#6dc3d3';
        fabric.Object.prototype.cornerStyle = 'circle';
        fabric.Object.prototype.cornerSize = 20;
        fabric.Object.prototype.cornerStrokeColor = '#ffffff';
        fabric.Object.prototype.borderScaleFactor = 0.4;
        fabric.Object.prototype.transparentCorners = false;
        fabric.Object.prototype.setControlsVisibility({
            tl: true,
            tr: true,
            br: true,
            bl: true,
            ml: false,
            mt: false,
            mr: false,
            mb: false,
            mtr: true
        });
        //
        // console.log(fabric.Object.prototype);
        // fabric.Image.fromURL('../example/img/titleBg.svg', function (image) {
        //     canvas.add(image);
        //     canvas.sendToBack(image);
        // });

        var oData = {
            "objects": [{
                "type": "rect",
                "left": 50,
                "top": 50,
                "width": 50,
                "height": 50,
                "fill": "green",
                "overlayFill": null,
                "stroke": null,
                "strokeWidth": 1,
                "strokeDashArray": null,
                "scaleX": 1,
                "scaleY": 1,
                "angle": 0,
                "flipX": false,
                "flipY": false,
                "opacity": 1,
                "selectable": true,
                "hasControls": true,
                "hasBorders": true,
                "hasRotatingPoint": true,
                "transparentCorners": false,
                "perPixelTargetFind": true,
                "rx": 0,
                "ry": 0
            }, {
                "type": "circle",
                "left": 100,
                "top": 100,
                "width": 100,
                "height": 100,
                "fill": "red",
                "overlayFill": null,
                "stroke": null,
                "strokeWidth": 1,
                "strokeDashArray": null,
                "scaleX": 1,
                "scaleY": 1,
                "angle": 0,
                "flipX": false,
                "flipY": false,
                "opacity": 1,
                "selectable": true,
                "hasControls": true,
                "hasBorders": true,
                "hasRotatingPoint": false,
                "transparentCorners": false,
                "perPixelTargetFind": false,
                "radius": 50
            }]
        }
        //
        //
        console.log(postData);
        canvas.loadFromJSON(postData.complete);
        //
        // var textBox = new fabric.Text("POP\nCORN", {
        //     fontFamily: 'Arial Black',
        //     fontSize: '30',
        //     textAlign: 'center',
        //     lineHeight: '.8'
        // });
        // textBox.editable = false;


        // canvas.add(textBox);
        //

        //
        //'object:selected': this.canvasEventHandle.bind(this),
        canvas.on(
            {
                'mouse:down': this.canvasEventHandle.bind(this)
            }
        );
        //
        // PubSub.subscribe(CanvasEvents.SELECTED, this.onObjectSelected.bind(this));
        //
        // // this.setState({canvas}, () => {
        // //     this.initEvent.call(this);
        // //     Object.keys(this.ref).forEach(key => {
        // //         const ref = this.ref[key];
        // //         ref.draw(obj => this.add(obj));
        // //     });
        // // });
        // this.fitToScreen();
        PubSub.subscribe(ToolBoxEvents.FINISH,this.onDataChange.bind(this));
        PubSub.subscribe(ToolBoxEvents.RESET,this.onDataChange.bind(this));

        TweenMax.set('.canvas-container',{position:'absolute'})
    }

    onDataChange(msg,data){
        // console.log("SELECTED",msg);
        if(msg == ToolBoxEvents.RESET){
            console.log("Reset")
            canvas.loadFromJSON(postData.init);
        }else if(msg == ToolBoxEvents.FINISH){
            console.log("Finish")
            canvas.loadFromJSON(postData.complete);
        }


    }

    componentWillUnmount() {

    }

    fitToScreen() {


        let aw, ah, cw, ch,
            size = {width: 0, height: 0, scaleFactor: 1},
            screenWidth = window.innerWidth,
            screenHeight = window.innerHeight;

        // console.log(window,screenWidth);

        aw = screenWidth * Canvas.area.width;
        ah = screenHeight * Canvas.area.height;

        cw = this.original.width;
        ch = this.original.height;


        if (cw / ch > aw / ah) {
            size.width = aw;
            size.height = ch / cw * aw;
            size.scaleFactor = aw / cw;
            console.log('fitWidht:', size)
        } else {
            size.height = ah;
            size.width = cw / ch * ah;
            size.scaleFactor = ah / ch;
            console.log('fitHeight:', size)
        }


        canvas.setHeight(size.height);
        canvas.setWidth(size.width);
        canvas.setZoom(size.scaleFactor);

        // console.log(screenHeight,size.height);

        TweenMax.to('.canvas-container', .5, {
            left: (screenWidth - size.width) / 2,
            top: (screenHeight - size.height) / 2,
            ease: Power1.easeInOut
        })


    };

    canvasEventHandle(e) {

        // canvas.setZoom(Math.random() * 2)
        // console.log(canvas.getZoom())
        // console.log('this:', e);
        // root.zoom();
        // PubSub.publish(CanvasEvents.SELECTED, {e, this});
        if (e.target == null) {
            // console.log("clear",canvas.getActiveObject());
            PubSub.publish(CanvasEvents.SELECTED_CLEAR, {selected: false});
            // console.log(canvas.toDatalessObject(), JSON.stringify(canvas.toDatalessJSON(),null,4));
        } else {
            console.log("selected");
            console.log(e.target);
            PubSub.publish(CanvasEvents.SELECTED, {selected: true, object: canvas.getActiveObject()});
        }
    };

    onObjectSelected(msg, data) {
        // console.log(data,this);
        this.doSelected();

    }

    onResizeHandle(e) {
        // console.log(this, e);
        this.fitToScreen()
        // console.log(root)
        //root.zoom();
    }

    render() {
        const styles = getStyles(this.props);


        return (
            <canvas id={Canvas.id}>
                <EventListener target='window' onResize={this.onResizeHandle.bind(this)}/>
            </canvas>
        );
    }
}

export  default  Canvas;
