/**
 * Created by lion on 8/3/16.
 */

/**
 * Created by lion on 8/1/16.
 */

import React, {PropTypes, Component}  from 'react';

import TweenMax from 'gsap';

function getStyles(props, context) {
    // const {tabs} = context.muiTheme;

    return {
        container: {

            // position: 'relative',
            display: 'flex',
            flexDirection: 'row',
            justifyContent: 'center',
            alignItems: 'center',

            width: props.sizeState.width,
            height: props.sizeState.width,
            margin: `${props.sizeState.width*props.sizeState.ratio}px 0 0 0`,
            borderRadius: '100%',

            backgroundColor: props.backgroundColor,

            cursor: 'pointer',

            boxShadow: '0 4px 8px rgba(0, 0, 0, .45)',

            flexShrink:0
        },
        iconContainer: {
            display: 'flex',
            flexDirection: 'column',
            justifyContent: 'center',
            alignItems: 'center',

            width: 24,
            height: 24,
        }
    };
}


class AssistItem extends Component {


    static propTypes = {

        clickHandle: PropTypes.func,

        icon: PropTypes.node,

        backgroundColor: PropTypes.string,

        hoverColor: PropTypes.string,

        style: PropTypes.object,

        collection:PropTypes.array,

        sizeState:PropTypes.object

    };

    static defaultProps = {
    }

    state = {
        hovered: false,
    };

    handleMouseLeave = (event) => {
        // this.setState({hovered: false});
        // this.props.onMouseLeave(event);
        // console.log("asdfasdf",this.editorMenuItem)
        this.transition(1);
    };

    handleMouseEnter = (event) => {
        // this.setState({hovered: true});
        // this.props.onMouseEnter(event);
        this.transition(1.2);
    };

    componentDidMount() {
        console.log('assistItemMount')
        this.props.collection.push(this.item);
    }

    transition = (iconValue,textValue) => {
        TweenMax.to(this.item, .5, {scale: iconValue,smoothOrigin:false,force3D:false, ease: Power2.easeOut})
        // TweenMax.to(this.text, .5, {op: textValue, ease: Power2.easeOut})
    };

    onClickHandle(e) {
        this.props.clickHandle();
    }

    render() {

        // const styles = getStyles(this.props);

        const {
            icon,
            style,
            backgroundColor,
            ...other,
        } = this.props;

        // console.log(icon);

        const styles = getStyles(this.props).container;

        const mergedStyles = Object.assign(styles, style);

        // console.log(mergedStyles,style);
        if(this.item){
            TweenMax.to(this.item, .6, {css:this.props.style,smoothOrigin:false,force3D:false, ease: Power2.easeInOut})
        }

        return (
            <div style={mergedStyles}
                 ref={(ref) => this.item = ref}
                 onMouseOver={this.handleMouseEnter.bind(this)}
                 onMouseOut={this.handleMouseLeave.bind(this)}>
                <div style={getStyles(this.props).iconContainer}>
                {icon}
                </div>
            </div>

        );
    }
}

export default AssistItem;
