/**
 * Created by lion on 8/1/16.
 */

import React, {PropTypes, Component}  from 'react';
import transitions from '../styles/transitions';

import TweenMax from 'gsap';

function getStyles(props, context) {
    // const {tabs} = context.muiTheme;

    return {
        container: {

            // position: 'relative',
            display: 'flex',
            flexDirection: 'row',
            justifyContent: 'center',
            alignItems: 'center',

            width: 50,
            height: 50,
            borderRadius: '100%',

            backgroundColor: props.backgroundColor,

            cursor: 'pointer',

            boxShadow: '0 4px 8px rgba(0, 0, 0, .45)',

            // transition:transitions.easeOut('300ms','all','.5s')
            // transitionDuration:'.4s'
            flexShrink:0
        }
    };
}


class CategorySwitch extends Component {


    static propTypes = {

        clickHandle: PropTypes.func,

        icon: PropTypes.node,

        backgroundColor: PropTypes.string,

        hoverColor: PropTypes.string,

        style: PropTypes.object

    };

    static defaultProps = {

        backgroundColor: '#01b58d',

        hoverColor: '#ff5500'

    }

    state = {
        hovered: false,
    };

    handleMouseLeave = (event) => {
        // this.setState({hovered: false});
        // this.props.onMouseLeave(event);
        // console.log("asdfasdf",this.editorMenuItem)
        this.transition(1,this.props.backgroundColor);
    };

    handleMouseEnter = (event) => {
        // this.setState({hovered: true});
        // this.props.onMouseEnter(event);
        this.transition(1.2,this.props.hoverColor);
    };

    transition = (value,color) => {
        TweenMax.to(this.item, .5, {scale:value,backgroundColor: color,smoothOrigin:false,force3D:false, ease: Power3.easeOut})
    };

    onClickHandle(e) {
        this.props.clickHandle();
    }

    render() {

        // const styles = getStyles(this.props);

        const {
            icon,
            backgroundColor,
            hoverColor,
            style,
            ...other,
        } = this.props;

        // console.log(this.props.style);

        const styles = getStyles(this.props).container;

        const mergedStyles = Object.assign(styles, style);

        // console.log(mergedStyles,style);
        if(this.item){
            TweenMax.to(this.item, .6, {css:this.props.style,smoothOrigin:false,force3D:false, ease: Power2.easeInOut})
        }

        return (
            <div style={mergedStyles}
                 ref={(ref) => this.item = ref}
                 onMouseOver={this.handleMouseEnter.bind(this)}
                 onMouseOut={this.handleMouseLeave.bind(this)}
                 onClick={this.onClickHandle.bind(this)}>
                {icon}
            </div>

        );
    }
}

export default CategorySwitch;