/**
 * Created by lion on 8/3/16.
 */

/**
 * Created by lion on 8/1/16.
 */

import React, {PropTypes, Component}  from 'react';

import TweenMax from 'gsap';

import transitions from '../styles/transitions';

function getStyles(props) {

    // console.log(props)

    return {
        container: {

            // position: 'relative',
            display: 'flex',
            flexDirection: 'column',
            justifyContent: 'center',
            alignItems: 'center',

            width: '100%',
            height: '40px',
            margin: `${props.sizeState.toolItemMargin}px 0`,

            // backgroundColor: 'rgba(0, 0, 0, .8)',

            cursor: 'pointer',

            transition:transitions.easeOut('.4s')
        },
        iconContainer: {
            display: 'flex',
            flexDirection: 'column',
            justifyContent: 'center',
            alignItems: 'center',

            width: 24,
            height: 24,
        },
        text: {
            fontFamily: 'Helvetica, "Hiragino Sans GB", "Microsoft Yahei", "微软雅黑", Arial, sans-serif',
            fontSize: '10px',
            color: '#fff',
            textAlign: 'center',
            lineHeight: 2
        }
    };
}


class ToolItem extends Component {


    static propTypes = {

        clickHandle: PropTypes.func,

        icon: PropTypes.node,

        text: PropTypes.string,

        style: PropTypes.object,

        collection: PropTypes.array,

        sizeState: PropTypes.object

    };

    static defaultProps = {
        text: 'tool'
    }

    state = {
        hovered: false,
    };

    handleMouseLeave = (event) => {
        // this.setState({hovered: false});
        // this.props.onMouseLeave(event);
        // console.log("asdfasdf",this.editorMenuItem)
        this.transition(1);
    };

    handleMouseEnter = (event) => {
        // this.setState({hovered: true});
        // this.props.onMouseEnter(event);
        this.transition(1.3);
    };

    transition = (iconValue, textValue) => {
        TweenMax.to(this.icon, .5, {scale: iconValue, smoothOrigin: false, force3D: false, ease: Power2.easeOut})
        // TweenMax.to(this.text, .5, {op: textValue, ease: Power2.easeOut})
    };

    componentDidMount() {
        // console.log('containerMount' + this.item)
        this.props.collection.push(this.item);
    }

    onClickHandle(e) {
        this.props.clickHandle();
    }

    render() {

        // const styles = getStyles(this.props);

        const {
            icon,
            style,
            ...other,
        } = this.props;

        // console.log(icon);

        const styles = getStyles(this.props).container;

        const mergedStyles = Object.assign(styles, style);


        return (
            <div ref={(ref)=>this.item = ref}
                 style={mergedStyles}
                 onMouseOver={this.handleMouseEnter.bind(this)}
                 onMouseOut={this.handleMouseLeave.bind(this)}>
                <div
                    ref={(ref)=>this.icon = ref}
                    style={getStyles(this.props).iconContainer}>
                    {icon}
                </div>
                {/*<div*/}
                    {/*ref={(ref)=>this.text = ref}*/}
                    {/*style={getStyles(this.props).text}>*/}
                    {/*{this.props.text}*/}
                {/*</div>*/}

            </div>

        );
    }
}

export default ToolItem;
