/**
 * Created by lion on 8/3/16.
 */

/**
 * Created by lion on 8/2/16.
 */

import React, {PropTypes, Component}  from 'react';

import ToolItem from './ToolItem';

import _ from 'underscore';

import transitions from '../styles/transitions';

function getStyles(props) {

    return {
        container: {
            display: 'flex',
            flexDirection: 'column',
            justifyContent: 'center',
            alignItems: 'center',
            flexShrink: 0,

            width: props.sizeState.width,
            // minHeight: '140px',
            margin: `${props.sizeState.width*props.sizeState.ratio}px 0 0 0`,
            padding: `${props.sizeState.width*props.sizeState.ratio}px 0`,

            borderRadius: props.sizeState.width/2,
            backgroundColor: props.backgroundColor,

            boxShadow: '0 4px 8px rgba(0, 0, 0, .45)',

            overflow: 'hidden',

            // transition:transitions.easeOut('.4s')
            // WebkitUserSelect:'none'
        },
        switch: {
            // backgroundColor: props.bgColor ? props.bgColor : lightBlack,
            // width: '100%',
            // height: '100%',
            // minWidth:1000
        }
    };
}

class ToolsContainer extends Component {

    static propTypes = {

        active: PropTypes.bool,

        backgroundColor: PropTypes.string,

        tools: PropTypes.object,

        collection: PropTypes.object,

        sizeState:PropTypes.object
    };

    static defaultProps = {
        backgroundColor: '#f0f',
        active: false
    }

    componentDidMount() {
        // console.log('containerMount' + this.item)
        this.props.collection.bg = this.container;
    }


    render() {

        var itemNum = 0,
            itemCollection = this.props.collection.items,
            thisProps = this.props;

        let toolItems = _.map(this.props.tools, function (item, key) {
            // console.log(item,item.name);
            itemNum++;
            return (
                <ToolItem
                    key={key}
                    icon={item.icon}
                    text={item.name}
                    collection={itemCollection}
                    sizeState={thisProps.sizeState}
                />
            );
        })

        // console.log(this.props.sizeState)

        const mergedStyles = Object.assign(getStyles(this.props).container, {});


        return (
            <div ref={(ref)=>this.container = ref}
                 style={mergedStyles}>
                {toolItems}
            </div>
        )

    }
}

export default ToolsContainer;
