/**
 * Created by lion on 8/2/16.
 */

import React from 'react';
import {red, blue, green} from '../styles/colors'
import {lighten,darken} from '../styles/colorManipulator'

import BackgroundImage from '../svg-icons/category/backgroundImage'
import Information from '../svg-icons/category/information'
import Proportion from '../svg-icons/category/proportion'

import ChangeBgImage from '../svg-icons/tools/changeBgImage'
import Transform from '../svg-icons/tools/tansform'


import FontShape from '../svg-icons/tools/fontShape'
import FontFamily from '../svg-icons/tools/fontFamily'
import FontSize from '../svg-icons/tools/fontSize'
import FontColor from '../svg-icons/tools/fontColor'
import Align from '../svg-icons/tools/align'
import FontSpace from '../svg-icons/tools/fontSpace'
import Opacity from '../svg-icons/tools/opacity'


import Forward from '../svg-icons/tools/forward'
import Backward from '../svg-icons/tools/backward'
import Edit from '../svg-icons/tools/edit'

export const config = {
    proportion: {
        type: 'proportion_tools',
        switch: {backgroundColor: blue, hoverColor: darken(blue, 0.2), icon: <Proportion/>}
    },
    backgroundImage: {
        type: 'background_image_tools',
        switch: {backgroundColor: green, hoverColor: darken(green, 0.2), icon: <BackgroundImage/>},
        tools: {changeBgImage: {name: '更换背景', icon: <ChangeBgImage/>}, transform: {name: '变换', icon: <Transform/>}},
        assist: {
            forward: {backgroundColor: green, hoverColor: darken(green, 0.2), icon: <Forward/>},
            backward: {backgroundColor: green, hoverColor: darken(green, 0.2), icon: <Backward/>},
            edit: {backgroundColor: green, hoverColor: darken(green, 0.2), icon: <Edit/>}
        }
    },
    information: {
        type: 'information_tools',
        switch: {backgroundColor: red, hoverColor: darken(red, 0.2), icon: <Information/>},
        tools: {
            fontShape: {name: '样式', icon: <FontShape/>},
            fontFamily: {name: '字体', icon: <FontFamily/>},
            fontSize: {name: '字号', icon: <FontSize/>},
            color: {name: '颜色', icon: <FontColor/>},
            align: {name: '对齐', icon: <Align/>},
            space: {name: '间距', icon: <FontSpace/>},
            opacity: {name: '透明度', icon: <Opacity/>},

        },
        assist: {
            forward: {backgroundColor: red, hoverColor: darken(red, 0.2), icon: <Forward/>},
            backward: {backgroundColor: red, hoverColor: darken(red, 0.2), icon: <Backward/>},
            edit: {backgroundColor: red, hoverColor: darken(red, 0.2), icon: <Edit/>}
        }
    }
};
export const configs = {
    information: {
        type: 'information_tools',
        switch: {backgroundColor: red, hoverColor: darken(red, 0.2), icon: <Information/>},
        tools: {
            fontShape: {name: '样式', icon: <FontShape/>},
            fontFamily: {name: '字体', icon: <FontFamily/>},
            fontSize: {name: '字号', icon: <FontSize/>},
            color: {name: '颜色', icon: <FontColor/>},
            align: {name: '对齐', icon: <Align/>},
            space: {name: '间距', icon: <FontSpace/>},
            opacity: {name: '透明度', icon: <Opacity/>},

        },
        assist: {
            forward: {backgroundColor: red, hoverColor: darken(red, 0.2), icon: <Forward/>},
            backward: {backgroundColor: red, hoverColor: darken(red, 0.2), icon: <Backward/>},
            edit: {backgroundColor: red, hoverColor: darken(red, 0.2), icon: <Edit/>}
        }
    }
};

export const SIZE = {
    normal:{
        width:56,ratio:.5
    },
    mini:{
        width:44,ratio:.2
    }
}

export class resizeState {
    static NORMAL = 'normal';
    static MINI = 'mini';
}
